const char table_lua[] =
"local function table_deepcopy_internal(orig, cyclic)\n"
"    cyclic = cyclic or {}\n"
"    local copy = orig\n"
"    if type(orig) == 'table' then\n"
"        local mt, copy_function = getmetatable(orig), nil\n"
"        if mt then copy_function = mt.__copy end\n"
"        if copy_function == nil then\n"
"            copy = {}\n"
"            if cyclic[orig] ~= nil then\n"
"                copy = cyclic[orig]\n"
"            else\n"
"                cyclic[orig] = copy\n"
"                for orig_key, orig_value in pairs(orig) do\n"
"                    local key = table_deepcopy_internal(orig_key, cyclic)\n"
"                    copy[key] = table_deepcopy_internal(orig_value, cyclic)\n"
"                end\n"
"                if mt ~= nil then setmetatable(copy, mt) end\n"
"            end\n"
"        else\n"
"            copy = copy_function(orig)\n"
"        end\n"
"    end\n"
"    return copy\n"
"end\n"
"\n"
"--- Deepcopy lua table (all levels)\n"
"-- Supports __copy metamethod for copying custom tables with metatables\n"
"-- @function deepcopy\n"
"-- @table         inp  original table\n"
"-- @shallow[opt]  sep  flag for shallow copy\n"
"-- @returns            table (copy)\n"
"local function table_deepcopy(orig)\n"
"    return table_deepcopy_internal(orig, nil)\n"
"end\n"
"\n"
"--- Copy any table (only top level)\n"
"-- Supports __copy metamethod for copying custom tables with metatables\n"
"-- @function copy\n"
"-- @table         inp  original table\n"
"-- @shallow[opt]  sep  flag for shallow copy\n"
"-- @returns            table (copy)\n"
"local function table_shallowcopy(orig)\n"
"    local copy = orig\n"
"    if type(orig) == 'table' then\n"
"        local mt, copy_function = getmetatable(orig), nil\n"
"        if mt then copy_function = mt.__copy end\n"
"        if copy_function == nil then\n"
"            copy = {}\n"
"            for orig_key, orig_value in pairs(orig) do\n"
"                copy[orig_key] = orig_value\n"
"            end\n"
"            if mt ~= nil then setmetatable(copy, mt) end\n"
"        else\n"
"            copy = copy_function(orig)\n"
"        end\n"
"    end\n"
"    return copy\n"
"end\n"
"\n"
"-- table library extension\n"
"local table = require('table')\n"
"table.copy     = table_shallowcopy\n"
"table.deepcopy = table_deepcopy\n"
""
;
